# Issue Template

Please review the [contribution](https://github.com/noopkat/avrgirl-arduino/blob/master/CONTRIBUTING.md) and [code of conduct](https://github.com/noopkat/avrgirl-arduino/blob/master/CODE_OF_CONDUCT.md) guidelines.

## Description

_If you raise an issue on bug/issue please provide the requested information, where not possible, please provide as many details as possible and ultimately a thorough description of your issue._

### Expected behaviour

_What behaviour did you expect did occur?_

### Actual behaviour

_What unexpected behaviour occurred?_

## Operating system and version

_Please provide version on the operating system etc. used._

### Windows (pre version 7)

`C:\> ver`

### Windows (Version 7 and newer)

`C:\> systeminfo | findstr /B /C:"OS Name" /C:"OS Version"`

### Linux and Unix based systems

`$ uname -a`

_For information on the specific distribution. Please consult your distribution documentation._

## Avrgirl Arduino version

_Please provide version on the Avrgirl Arduino version used_

_If working in a fork of the GitHub project, obtain this information post installation using:_

`$ npm list | grep avrgirl-arduino`

_If you are working on code, which has diverged from the lastest release, please mention this_.

## NodeJS version

_Please provide version on the Node version used._

`$ node --version`

## Arduino Board being used

_Please provide version/model on the Arduino board being used._

_A full List of boards and processor names are [available on Wikipedia](https://en.wikipedia.org/wiki/List_of_Arduino_boards_and_compatible_systems)._

## Log output, if available

_Please add any log output, which can be used to describe the issue or circumstances surrounding the issues._

## Step by step guide to reproducing the issue

_If possible a code snipppet to demonstrate the issue or a throught step by step description of how to get reproduce the error._
